gtkmm 3.24.0

Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gdk::FrameTimings Class Referencefinal

Object holding timing information for a single frame. More...

`#include <gdkmm/frametimings.h>`

## Public Member Functions
void | reference () const
| Increment the reference count for this object. More...
void | unreference () const
| Decrement the reference count for this object. More...
GdkFrameTimings* | gobj ()
| Provides access to the underlying C instance. More...
const GdkFrameTimings* | gobj () const
| Provides access to the underlying C instance. More...
GdkFrameTimings* | gobj_copy () const
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
| FrameTimings ()=delete
| FrameTimings (const FrameTimings&)=delete
FrameTimings& | operator= (const FrameTimings&)=delete
gint64 | get_frame_counter () const
| Gets the frame counter value of the Gdk::FrameClock when this this frame was drawn. More...
bool | get_complete () const
| The timing information in a Gdk::FrameTimings is filled in incrementally as the frame as drawn and passed off to the window system for processing and display to the user. More...
gint64 | get_frame_time () const
| Returns the frame time for the frame. More...
gint64 | get_presentation_time () const
| Reurns the presentation time. More...
gint64 | get_refresh_interval () const
| Gets the natural interval between presentation times for the display that this frame was displayed on. More...
gint64 | get_predicted_presentation_time () const
| Gets the predicted time at which this frame will be displayed. More...

## Protected Member Functions
void | operator delete (void*, std::size_t)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gdk::FrameTimings > | wrap (GdkFrameTimings* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Detailed Description

Object holding timing information for a single frame.

A Gdk::FrameTimings object holds timing information for a single frame of the application’s displays. To retrieve Gdk::FrameTimings objects, use Gdk::FrameClock::get_timings() or Gdk::FrameClock::get_current_timings(). The information in Gdk::FrameTimings is useful for precise synchronization of video with the event or audio streams, and for measuring quality metrics for the application’s display, such as latency and jitter.

Since gtkmm 3.24:

## Constructor & Destructor Documentation

## ◆ FrameTimings() [1/2]

Gdk::FrameTimings::FrameTimings | ( |  | ) |
| delete

## ◆ FrameTimings() [2/2]

Gdk::FrameTimings::FrameTimings | ( | const FrameTimings& |  | ) |
| delete

## Member Function Documentation

## ◆ get_complete()

bool Gdk::FrameTimings::get_complete | ( |  | ) | const

The timing information in a Gdk::FrameTimings is filled in incrementally as the frame as drawn and passed off to the window system for processing and display to the user.

The accessor functions for Gdk::FrameTimings can return 0 to indicate an unavailable value for two reasons: either because the information is not yet available, or because it isn't available at all. Once get_complete() returns `true` for a frame, you can be certain that no further values will become available and be stored in the Gdk::FrameTimings.

Since gtkmm 3.8:

Returns
  `true` if all information that will be available for the frame has been filled in.

## ◆ get_frame_counter()

gint64 Gdk::FrameTimings::get_frame_counter | ( |  | ) | const

Gets the frame counter value of the Gdk::FrameClock when this this frame was drawn.

Since gtkmm 3.8:

Returns
  The frame counter value for this frame.

## ◆ get_frame_time()

gint64 Gdk::FrameTimings::get_frame_time | ( |  | ) | const

Returns the frame time for the frame.

This is the time value that is typically used to time animations for the frame. See Gdk::FrameClock::get_frame_time().

Returns
  The frame time for the frame, in the timescale of Glib::get_monotonic_time().

## ◆ get_predicted_presentation_time()

gint64 Gdk::FrameTimings::get_predicted_presentation_time | ( |  | ) | const

Gets the predicted time at which this frame will be displayed.

Although no predicted time may be available, if one is available, it will be available while the frame is being generated, in contrast to get_presentation_time(), which is only available after the frame has been presented. In general, if you are simply animating, you should use Gdk::FrameClock::get_frame_time() rather than this function, but this function is useful for applications that want exact control over latency. For example, a movie player may want this information for Audio/Video synchronization.

Since gtkmm 3.8:

Returns
  The predicted time at which the frame will be presented, in the timescale of Glib::get_monotonic_time(), or 0 if no predicted presentation time is available.

## ◆ get_presentation_time()

gint64 Gdk::FrameTimings::get_presentation_time | ( |  | ) | const

Reurns the presentation time.

This is the time at which the frame became visible to the user.

Since gtkmm 3.8:

Returns
  The time the frame was displayed to the user, in the timescale of Glib::get_monotonic_time(), or 0 if no presentation time is available. See get_complete().

## ◆ get_refresh_interval()

gint64 Gdk::FrameTimings::get_refresh_interval | ( |  | ) | const

Gets the natural interval between presentation times for the display that this frame was displayed on.

Frame presentation usually happens during the “vertical blanking interval”.

Since gtkmm 3.8:

Returns
  The refresh interval of the display, in microseconds, or 0 if the refresh interval is not available. See get_complete().

## ◆ gobj() [1/2]

GdkFrameTimings* Gdk::FrameTimings::gobj | ( |  | ) |

Provides access to the underlying C instance.

## ◆ gobj() [2/2]

const GdkFrameTimings* Gdk::FrameTimings::gobj | ( |  | ) | const

Provides access to the underlying C instance.

## ◆ gobj_copy()

GdkFrameTimings* Gdk::FrameTimings::gobj_copy | ( |  | ) | const

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator delete()

void Gdk::FrameTimings::operator delete | ( | void * | ,
|  | std::size_t |
| ) |  |
| protected

## ◆ operator=()

FrameTimings& Gdk::FrameTimings::operator= | ( | const FrameTimings& |  | ) |
| delete

## ◆ reference()

void Gdk::FrameTimings::reference | ( |  | ) | const

Increment the reference count for this object.

You should never need to do this manually - use the object via a RefPtr instead.

## ◆ unreference()

void Gdk::FrameTimings::unreference | ( |  | ) | const

Decrement the reference count for this object.

You should never need to do this manually - use the object via a RefPtr instead.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gdk::FrameTimings > wrap | ( | GdkFrameTimings * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.